module MedicalSupplierApi
  module Connection
    class Besse
      BASE_URL   = 'https://abcapimneodev.amerisourcebergen.com'
      LIST_PATH  = '/inventory/atp/api/v1/atpcheck'
      ORDER_PATH = '/ordering/invsysorder/api/v1/inboundsalesorder'

      def initialize(username: , password: , customer_number: , generics: false)
        @username = username
        @password = password
        @customer_number = customer_number
        @generics = (true == generics)
      end

      def check_inventory(items: , url: "#{BASE_URL}#{LIST_PATH}")
        data = self.class.build_account_info(customer_number: @customer_number, generics: @generics, items: items)

        response = HTTParty.post(url, body: data.to_json, basic_auth: auth)

        MedicalSupplierApi::Models::Besse::AtpResponse.new(response: response)
      end

      def self.build_account_info(customer_number: , generics: , items: )
        MedicalSupplierApi::Models::Besse::AccountInfo.new(
          customer_number: customer_number,
          generics: generics,
          items: items.map(&:to_h)
        ).as_json
      end

      private
      def auth
        {
          username: @username,
          password: @password
        }
      end
    end
  end
end
