module MedicalSupplierApi
  module Models
    module Besse
      class Item < Hashie::Trash
        include Hashie::Extensions::IgnoreUndeclared
        include Hashie::Extensions::IndifferentAccess

        property :ItemNumber, from: :item_number, required: false
        property :OrderQty, from: :quantity, required: false
        property :ATP, required: false
        property :ItemDesc, required: false

        alias_method :item_number, :ItemNumber
        alias_method :description, :ItemDesc

        def quantity
          self[:OrderQty].to_i
        end
      end
    end
  end
end
